#include "segDTWT.h"

#include <iostream>

int main(int argc, char *argv[]){


separableWavelet* wav = new separableWavelet("sym6","../wavelets.dat");

int level = 5;
//segSize.height = 2;
//segSize.width = 2;
extensionType = SYMETRIC_WP;

int i_widthStep;
Size i_size;
int R = r(level,wav->getLength());


float* i_data = loadWrapAlignTGA("../../tga/lena1800.tga",r(level,wav->getLength()),&i_widthStep,&i_size);


float** subbands = new float*[level*3+1];
int* subbandWidthStep = new int[level*3+1];
allocateSubbands(subbands,subbandWidthStep,level,wav->getLength(),wav->getLength(),i_size);
int o_widthStep;
float *o_data = allocateImage_32f_C1(i_size.width,i_size.height,&o_widthStep);
segDTWTfwd_32f_C1(i_data, i_widthStep, subbands, subbandWidthStep, level, i_size, wav);
segDTWTinv_32f_C1(subbands,subbandWidthStep,o_data,o_widthStep,level,i_size,wav);

double error = 0;
float* input = i_data + r(level,wav->getLength())*i_widthStep/sizeof(float) + r(level,wav->getLength());
	for(int y = 0;y<i_size.height;y++){
		for(int x=0;x<i_size.width;x++){
			error += abs((  *(input + x + y*i_widthStep/sizeof(float))  - (int)(*(o_data+ x + y*o_widthStep/sizeof(float)) + 0.5) ));
		}
	}
std::cout<<"MSE: " << error << std::endl ;


//saveTGA("output.tga",o_data,o_widthStep,i_size);

releaseSubbands(subbands,level);
releaseImage(i_data);
delete wav;

std::cout<< "Finish! Press a key.";
std::cin.get();


}