#ifndef __TBB_blocked_range_segdtwt_segidtwt_auto_H
#define __TBB_blocked_range_segdtwt_segidtwt_auto_H
#include "tbb/tbb_stddef.h"
#include "types.h"

namespace tbb {
 

 template<typename Value>
/* 
pipraven pro begin = 0, end = width + 2*r(J)


*/
 class blocked_range_segdtwt_segidtwt_auto{
 public:
    typedef Value const_iterator;
    typedef size_t size_type;
    blocked_range_segdtwt_segidtwt_auto() : my_begin(), my_end(), first(true), last(true) { }
	// grainsize mus bt vt ne (2^J)
	// my_begin =0 my_end = width + 2*R;
	// my_begin a my_end sou "ostr" hodnoty pro vpoet
	// my_begin_orig=R a my_end_orig = width-R
	// begin_ a end_ jsou pvodn rozmry 0-width
	// filter_length je dlka nejdelho pouitho filtru

	bool isFirst() const {return first;}
	bool isLast() const {return last;}

     blocked_range_segdtwt_segidtwt_auto( Value begin_, Value end_, size_t filter_length,size_t filter_length_low,size_t level,size_type grainsize_=1 ) : 
	 filter_length(filter_length) , level(level), my_grainsize(grainsize_), filter_length_low(filter_length_low)
     {
		 __TBB_ASSERT( my_grainsize>=(Value)pow2(level), "grainsize must be 2*2^level or bigger" );
		// poet spolench prvk dvou sousednch segment
		 R = (pow2(level)-1)*(filter_length - 1);	

		 my_end = (end_-begin_) + 2*R;
		 my_begin = begin_;

		 my_begin_orig = my_begin + R;
		 my_end_orig = end_ + R; 

		first = true;
		last = true;

		// lev prodlouen prvnho segmentu je vdycky R 
		LT = R;

		// prav prodlouen aktulnho sezmentu nastav prozatm na R (kdyby byl jen jeden)
        RB = R;

		begin_whole = my_begin_orig;
		end_whole = my_end_orig;
     }
 
    const_iterator begin() const {return my_begin;}
 
    const_iterator end() const {return my_end;}

	int begin_orig() const {return my_begin_orig;}

	int end_orig() const {return my_end_orig;}

    size_type size() const {  return size_type(my_end-my_begin);  }

	size_type size_orig() const { return size_type(my_end_orig - my_begin_orig);  }

    size_type grainsize() const {return my_grainsize;}

	 // tolik koeficient v rovni k je teba zkoprovat na vstup
	  size_type subband_size(int k) const {
		  if(k==0) return size();
		  // pokud segment nen posledn segment
		  if(!last)
			return floor((float)(size())/pow2(k)+(1.0f/pow2(k)-1)*(filter_length-1)) - (pow2(level-k)-1)*(filter_length - 1);
		  else{
			  /* jinak je teba vzt v vahu, e posledn segment me bt velikosti [1-s], ve vych rovnch dekompozice pak
			  navc me bt 0 koeficient
			  */

			return max(0, floor( (float)((my_end_orig - my_begin)/pow2(k) )) - (pow2(level-k)-1)*(filter_length - 1)    );
		  }
     }

	  // tolik koeficient v rovni k je teba zkoprovat + prava na rzn dlky filtr, zvisl je ne n pouze velikost poslednho segmentu
	  size_type subband_size(int k,int filter_actual) const {
		  if(k==0) return size();
		  if(!last){
				return (size_type)( max(0,floor((float)(size())/pow2(k)+(1.0f/pow2(k)-1)*(filter_length-1)) - (pow2(level-k)-1)*(filter_length - 1)) );
		  }else{
			  int pokus = (int) ((filter_actual - (int)filter_length_low )/2);
			  int vracim = (int) ( max(0, floor( (float)((my_end_orig - my_begin - R + (pow2(level)-1)*(filter_length_low-1)   )/pow2(k) ) ) - (pow2(level-k)-1)*(filter_length_low - 1) + pokus )  );
return (size_type) vracim;
			
		
		  }
     }


      // od tohoto indexu zanu vytat koeficienty v k-t rovni odpovd r(J-k), 
	  size_type offset_in_subband(int k) const {  return (pow2(level-k)-1)*(filter_length - 1);  }
	
	  // index na kterm zan aktuln segment ve vstupnm subbandu 
	  size_type offset_in_output(int k) const {
		  int s = my_begin_orig-R; // dlka fiktivnho 1. segmentu (jakoby spojen vechny pedchoz)
		  if(s==0) return 0;
		  int ss = my_begin_orig + (R-LT); // dlka prodlouenho fiktivnho 1. segmentu
		  return (size_type) floor(ss/pow2(k)+(1.0f/pow2(k)-1)*(filter_length-1)) - (pow2(level-k)-1)*(filter_length - 1) + 1;	
	  }


	  /******* Metody pro inverzn transformaci ****/
	/** funkce udv zatek psobnosti koeficient aktulnho sehmentu v rozmrech rekonstruovanho obrazu ji bez prodlouen*/
	  size_type offset_in_reconstruced() const {
		  if(first) return 0;
			   // delka 1. segmentu	   prvnch r(J) bylo ostranno	   prav prodlouen pedchozho segmentu	
		  int out = (int)(my_begin_orig) - R             - R                       + R - LT;

		  // pokud bych se ve vstupu dostal do tch r(J) na zatku, kter rovnou odstrauju
		  return max(0,out); 
	  }

	
	  size_type offset_in_reconstructed_segment() const{
	  if(first) return R; 

	  if(my_begin < begin_whole) return begin_whole - my_begin; // prava offsetu v aktulnm segmentu. Nutn aby se zaalo koeficienty, kter zanaj a za r(J)

	  return 0;
	  }

	  	// poet vzorkzskanch inverzn transformac, prvn aposledn zkrceny o R
		size_type inverse_size() const { 
			size_type size = 0;
		if(first && last) size = size_type(my_end-my_begin - 2*R);
		else if(first || last) size = size_type(my_end-my_begin - R);
		else size = size_type(my_end-my_begin - offset_in_reconstructed_segment());  

		int over = size + my_begin + offset_in_reconstructed_segment() - end_whole;
		if( over > 0 ) size = size - over;

		return size;
		}


	
     //------------------------------------------------------------------------
     // Methods that implement Range concept
     //------------------------------------------------------------------------
 
     bool empty() const {return !(my_begin<my_end);}
 
	 bool is_divisible() const {
		 int size_oo = size_orig();
		 
		 return size_oo>((int)my_grainsize) && (size_oo/2)>=pow2(level);
	 }

	 // splitting konstruktor r je "pvodn", konstruktor tvo "nov"
     blocked_range_segdtwt_segidtwt_auto( blocked_range_segdtwt_segidtwt_auto& r, split ): 
	 my_end_orig(r.my_end_orig),my_end(r.my_end),RB(r.RB),my_grainsize(r.my_grainsize), 
		 level(r.level),filter_length(r.filter_length),R(r.R),filter_length_low(r.filter_length_low){

		this->last = r.last;
		this->first = false;
		r.last = false;

		this->begin_whole = r.begin_whole;
		this->end_whole = r.end_whole;
		
 

		// Value middle = (r.my_end_orig - r.my_begin_orig)/2 + r.my_begin_orig;
		Value middle = (r.my_end_orig - r.my_begin_orig)/2 + r.my_begin_orig;
		Value middle_orig = middle - R;
		int size1 = middle - r.my_begin_orig;
		int size2 = r.my_end_orig - middle;

	
		Value RBmin, RBmax;
		 // prav prodlouen pvodnho segmentu vypotan z rozmr pedchozho segmentu
		 RBmin = (Value) ( pow2(level)*ceil((float)((int)middle_orig)/pow2(level)) - (int)middle_orig);
		 RBmax = (Value) (pow2(level)*floor((float)(middle_orig+R)/pow2(level)) - middle_orig);

		// tady mus urit vyjt cel slo
		 int steps = (RBmax - RBmin)/pow2(level);
		// __TBB_ASSERT( ((RBmax - RBmin)/pow2(level))!=steps, "Chyba v prodlouzenich" );

		 int minK = 0;
		 int temp = r.LT - RB - R + size1 - size2;
		 int minimum =  abs( (int) (temp + 2*RBmin)  );

		 for(int k=1;k<=steps;k++){
			 if(pow2(level)*k + RBmin + r.my_end_orig > end_whole) break; //test jestli prodlouen s aktulnm k nebude mimo rozsah
			 if(	minimum > abs((int)( temp + 2*RBmin + 2*pow2(level)*k ))){
				minK = k;
				minimum = abs((int)( temp + 2*RBmin + 2*pow2(level)*k ));
				}
		 }
	//	minK = 0;

		r.RB = pow2(level)*minK + RBmin;

		LT = R - r.RB;

		// konec pvodnho segmentu v originlnch rozmrech
		 r.my_end_orig = middle;

		 // prodlouen konec
		 r.my_end = middle + r.RB;

		// nov segment zan na
		 my_begin_orig = middle;
		 // lev prodlouen
		 my_begin = middle - LT;

		 }
 private:
	// prodlouen velikost 0-s_width + 2*R(J)
	// 
    Value my_end; 
    Value my_begin;
	// pvodni velikost 0-width 
	// 
	Value my_end_orig;
    Value my_begin_orig;


	Value end_whole;
    Value begin_whole;

    size_type my_grainsize;

	size_t LT,RB; // prodlouen pro aktuln segment
	size_t filter_length; // dlka nejdelho filtru
	size_t filter_length_low; // dlka doln propusti
	size_t level; // stupen dekompozice
	int R;
	bool first,last;

	// left je pvodn,
//	static void do_split(blocked_range_segdtwt_segidtwt_auto& left,blocked_range_segdtwt_segidtwt_auto& right){	}

     template<typename RowValue, typename ColValue>
     friend class blocked_range2d_segdtwt_segidtwt_auto;
 
 };


 // blocked range pro obrazov bloky
 template<typename RowValue, typename ColValue=RowValue>
 class blocked_range2d_segdtwt_segidtwt_auto {
 public:
     typedef blocked_range_segdtwt_segidtwt_auto<RowValue> row_range_type;
    typedef blocked_range_segdtwt_segidtwt_auto<ColValue> col_range_type;
 
 private:
     row_range_type my_rows;
     col_range_type my_cols;
 
 public:
     blocked_range2d_segdtwt_segidtwt_auto( RowValue row_begin, RowValue row_end, RowValue row_filter_length,RowValue row_filter_length_low,typename row_range_type::size_type row_grainsize,
                      ColValue col_begin, ColValue col_end,  RowValue col_filter_length,RowValue col_filter_length_low,typename col_range_type::size_type col_grainsize, size_t level ) : 
         my_rows(row_begin,row_end,row_filter_length,row_filter_length_low,level,row_grainsize),
         my_cols(col_begin,col_end,col_filter_length,col_filter_length_low,level,col_grainsize) {}
 
     blocked_range2d_segdtwt_segidtwt_auto( RowValue row_begin, RowValue row_end,
                      ColValue col_begin, ColValue col_end ) : 
         my_rows(row_begin,row_end),
         my_cols(col_begin,col_end){}

     bool empty() const {
         // Yes, it is a logical OR here, not AND.
         return my_rows.empty() || my_cols.empty();
     }
     bool is_divisible() const {
         return my_rows.is_divisible() || my_cols.is_divisible();
     }
 
     blocked_range2d_segdtwt_segidtwt_auto( blocked_range2d_segdtwt_segidtwt_auto& r, split )
     {
	
	//	 std::cout<<r.my_rows.is_divisible() <<" "<< r.my_cols.is_divisible() <<std::endl;


		 if(r.my_rows.is_divisible()){
			my_cols = r.my_cols;
			my_rows =  row_range_type(r.my_rows,split());
		 } else {
			my_rows = r.my_rows;
			my_cols =  col_range_type(r.my_cols,split());
		 }
/*
		 if( (r.my_rows.size() < r.my_cols.size()) ) {
			my_rows = r.my_rows;
			my_cols =  col_range_type(r.my_cols,split());
        } else {
			my_cols = r.my_cols;
			my_rows =  row_range_type(r.my_rows,split());
         }*/


     }
 
    const row_range_type& rows() const {return my_rows;}
 
     const col_range_type& cols() const {return my_cols;}
 };





 }
#endif