#include "bodySegDTWT2D.h"


// size = s + 2*(m-1)
// vsledek bude dlky floor((size -( filter_size -1))/2)
void convolveRow(float* i, int size,float* o,float* filter,int filter_size){
    float* temp;
	for(int x=SUBSAMPLING;x<size-filter_size+1;x+=2){
		temp = i + x;
		float sum1 = 0.0f;
		for(int y=0;y<filter_size;y++){
		  sum1 += temp[y]*filter[y];
		}
        *(o + (x>>1)) = sum1 ;
		sum1 = 0;
	}
}

// konvoluce filtrem kratm ne pro kter bylo prodluovno
// filter_size je krat filtr
// vsledek je dlky floor((size -( filter_size + zerosLeft + zerosRight -1))/2) (take stejn jako ml del)
void convolveRow(float* i, int size, float* o,float* filter,int filter_size,int zerosLeft,int zerosRight){
    float* temp;
	//int filter_size = filter_size_max - zerosRight - zerosLeft;
	for(int x=SUBSAMPLING+zerosLeft;x<size-filter_size-zerosRight+1;x+=2){
		temp = i + x;
		float sum1 = 0.0f;
		for(int y=0;y<filter_size;y++){
		  sum1 += temp[y]*filter[y];
		}
        *(o + ((x-zerosLeft)>>1)) = sum1 ;
		sum1 = 0;
	}
}



// size = s + 2*(m-1)
// vsledek bude dlky floor((size -( filter_size -1))/2)
void convolveCol(float* i, int size,int i_widthStep,float* o,int o_widthStep,float* filter,int filter_size){
    float* temp;
	int x;
	for(x=SUBSAMPLING;x<size-filter_size+1;x+=2){
		temp = i + x*(i_widthStep);
		float sum1 = 0.0f;
		for(int y=0;y<filter_size;y++){
		  sum1 += *(temp +y*i_widthStep)*filter[y];
		}
        *(o + (x/2)*(o_widthStep) ) = sum1 ;
		sum1 = 0;
	}
}

// konvoluce sloupce filtrem kratm, ne pro kter bylo prodloueno, vstupnch koeficient by ale mlo bt stejn
void convolveCol(float* i, int size,int i_widthStep,float* o,int o_widthStep,float* filter,int filter_size,int zerosTop,int zerosBottom){
    float* temp;
	int x;
	// for(x=SUBSAMPLING+zerosTop;x<size-filter_size-zerosBottom + 1;x+=2){ // star verze
	for(x=SUBSAMPLING+zerosTop;x<size-filter_size-zerosBottom+1 ;x+=2){
		temp = i + x*(i_widthStep);
		float sum1 = 0.0f;
		for(int y=0;y<filter_size;y++){
		  sum1 += *(temp +y*i_widthStep)*filter[y];
		}
        *(o + ((x-zerosTop)/2)*(o_widthStep) ) = sum1 ;
		sum1 = 0;
	}
}


void bodySegDTWT2D::operator()(const tbb::blocked_range2d_segdtwt_segidtwt_auto<size_t>& r){

		int begin_cols = r.cols().begin();	// zatek bloku ve smru x
		int end_cols = r.cols().end();		// konec bloku ve smru x (u nepat do intervalu)			
		int begin_rows = r.rows().begin();	// zatek bloku ve smru y 
		int end_rows = r.rows().end();		// konec bloku ve smru y (u nepat do intervalu)
		int size_cols = end_cols - begin_cols;	// velikost bloku ve smru x
		int size_rows = end_rows - begin_rows;	// velikost bloku ve smru y

		int widthHalf = (size_cols-(w->getMaxFilterLengthCols()-1))/2;
		int heightHalf = (size_rows-(w->getMaxFilterLengthRows()-1))/2;

		if(widthHalf>maxWidthHalf || heightHalf>maxHeightHalf){
			if(H_buffer!=NULL) { releaseImage(H_buffer);} 
			H_buffer = allocateImage_32f_C1(widthHalf,size_rows,&H_buffer_widthStep); 
			if(L_buffer!=NULL){ releaseImage(L_buffer);} 
			L_buffer = allocateImage_32f_C1(widthHalf,size_rows,&L_buffer_widthStep);
			if(LL_buffer!=NULL){releaseImage(LL_buffer);} 
			LL_buffer = allocateImage_32f_C1(widthHalf,heightHalf,&LL_buffer_widthStep);
			if(LH_buffer!=NULL){releaseImage(LH_buffer);} 
			LH_buffer = allocateImage_32f_C1(widthHalf,heightHalf,&LH_buffer_widthStep);
			if(HL_buffer!=NULL){releaseImage(HL_buffer);} 
			HL_buffer = allocateImage_32f_C1(widthHalf,heightHalf,&HL_buffer_widthStep);
			if(HH_buffer!=NULL){releaseImage(HH_buffer);} 
			HH_buffer = allocateImage_32f_C1(widthHalf,heightHalf,&HH_buffer_widthStep);
			maxWidthHalf = widthHalf; maxHeightHalf = heightHalf;
		}

		// width step v potu float
		int i_widthStep_float = i_widthStep/sizeof(float);	
		
		// posun ukazatele na zatek bloku ve vstupnch datech
		float* i_begin = i_data + begin_rows*i_widthStep_float + begin_cols;

		// pomock promnn ukazujc na zatky dk
		float* i_row;
		// pomocn promnn ukazujc na zatky dk v bufferech
		float* buffer_row;

		// pomocn promnn pro offsety v bufferech
		float* in_buffer;
		float* out_temp;
		////////////

	/*	
		int R = (pow2(level)-1)*(w->getMaxFilterLengthCols()-1);
		std::cout<< "["<< (r.rows().begin_orig()-R) << "," << (r.cols().begin_orig()-R)<<"]"<< "["<< (r.rows().end_orig()-R) << "," << (r.cols().end_orig()-R)<<"]"<<std::endl; 
*/

		// k rove dekompozice
for(int k = 1;k<=level;k++){

	// aktuln dek ze vstupu
		 i_row = i_begin + w->getLeftZeros(0);
	//i_row = i_begin;
		// ukazatel na buffer L_buffer
		buffer_row = L_buffer;
		 

		// doln propust dky
		for(int i =0;i<size_rows;i++){
			convolveRow(i_row,size_cols,buffer_row,w->getAnalysingFilter(0),w->getAnalysingFilterLength(0),w->getLeftZeros(0),w->getRightZeros(0));
			i_row += i_widthStep_float;
			buffer_row += L_buffer_widthStep/sizeof(float);
		}
	
		// obnoven aktulnho dku ze vstupu
		  i_row = i_begin + w->getLeftZeros(1);
		//i_row = i_begin ;
		 buffer_row = H_buffer;

		// horn propust dky
		for(int i =0;i<size_rows;i++){
			convolveRow(i_row,size_cols,buffer_row,w->getAnalysingFilter(1),w->getAnalysingFilterLength(1),w->getLeftZeros(1),w->getRightZeros(1));
			i_row += i_widthStep_float;
			buffer_row += L_buffer_widthStep/sizeof(float);
		}


		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		// ukazatel na zatek bufferu H_buffer
		 i_row = H_buffer + (w->getTopZeros(0))*H_buffer_widthStep/sizeof(float); 
		//i_row = H_buffer;
		 buffer_row = HL_buffer;
		
		 // size_cols = (size_cols - w->getMaxFilterLengthCols() +1 - max(0,w->getAnalysingFilterLength(1) - w->getAnalysingFilterLength(0) ) )/2;

		 int hf = max(0,w->getAnalysingFilterLength(1) - w->getAnalysingFilterLength(0) );
		  size_cols = (size_cols - w->getMaxFilterLengthCols() +1 -hf )/2;

      

		// horn propust dky + doln propust sloupce
		for(int i =0;i<size_cols;i++){
			convolveCol(i_row,size_rows,H_buffer_widthStep/sizeof(float),buffer_row,HL_buffer_widthStep/sizeof(float),
						w->getAnalysingFilter(0),w->getAnalysingFilterLength(0),w->getTopZeros(0),w->getBottomZeros(0));
			i_row ++;
			buffer_row++;
		}

		 i_row = H_buffer +(w->getTopZeros(1))*H_buffer_widthStep/sizeof(float); 
		// i_row = H_buffer;
		 buffer_row = HH_buffer;
		// horn propust dky + horn propust sloupce
		for(int i =0;i<size_cols;i++){
			convolveCol(i_row,size_rows,H_buffer_widthStep/sizeof(float),buffer_row,HH_buffer_widthStep/sizeof(float),
						w->getAnalysingFilter(1),w->getAnalysingFilterLength(1),w->getTopZeros(1),w->getBottomZeros(1));
			i_row ++;
			buffer_row++;
		}

		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		 i_row = L_buffer +(w->getTopZeros(1))*H_buffer_widthStep/sizeof(float); 
		//i_row = L_buffer;
		 buffer_row = LH_buffer;
		// doln propust dky + horn propust sloupce
		for(int i =0;i<size_cols;i++){
			convolveCol(i_row,size_rows,L_buffer_widthStep/sizeof(float),buffer_row,LH_buffer_widthStep/sizeof(float),
						w->getAnalysingFilter(1),w->getAnalysingFilterLength(1),w->getTopZeros(1),w->getBottomZeros(1));
			i_row ++;
			buffer_row++;
		}

		 i_row = L_buffer +(w->getTopZeros(0))*L_buffer_widthStep/sizeof(float); 
		// i_row = L_buffer;
		 buffer_row = LL_buffer;
		// doln propust dky + doln propust sloupce
		for(int i =0;i<size_cols;i++){
			convolveCol(i_row,size_rows,L_buffer_widthStep/sizeof(float),buffer_row,LL_buffer_widthStep/sizeof(float),
						w->getAnalysingFilter(0),w->getAnalysingFilterLength(0),w->getTopZeros(0),w->getBottomZeros(0));
			i_row ++;
			buffer_row++;
		}

	//	int r = (pow2(level-k))*(w.length-1);

		// uloen LH,HH,HL subpsem na vstup (odebr se r(J-k) vzork zleva)

		// offset do bufferu HL na platn data Posun o r(J-k)
		in_buffer = HL_buffer + r.rows().offset_in_subband(k)*HL_buffer_widthStep/sizeof(float) + r.cols().offset_in_subband(k);
		// posun ve vstupnm subbandu HL na pozici platnou pro aktuln blok
		out_temp = o_data[3*(k-1)] + r.rows().offset_in_output(k)*widthSteps[3*(k-1)]/sizeof(float) + r.cols().offset_in_output(k);

		int temp = w->getAnalysingFilterLength(1);

int a = r.rows().subband_size(k,w->getAnalysingFilterLength(0));
int aa = r.cols().subband_size(k,w->getAnalysingFilterLength(1));

	//	std:: cout <<"Rozmery: "<< r.rows().subband_size(k,w->getAnalysingFilterLength(0)) <<" a " <<r.rows().subband_size(k,w->getAnalysingFilterLength(1)) <<std::endl;
		for(unsigned int i = 0;i<r.rows().subband_size(k,w->getAnalysingFilterLength(0));i++){
			memcpy( out_temp+i*widthSteps[3*(k-1)]/sizeof(float),		// kam
					in_buffer+i*HL_buffer_widthStep/sizeof(float),		// odkud
					r.cols().subband_size(k,w->getAnalysingFilterLength(1))*sizeof(float)); // kolik byt
		}

		// uloen HH psma na vstup
		// offset do bufferu HH na platn data
		 in_buffer = HH_buffer + r.rows().offset_in_subband(k)*HH_buffer_widthStep/sizeof(float) + r.cols().offset_in_subband(k);
		 // posun ve vstupnm subbandu HH na pozici platnou pro aktuln blok
		 out_temp = o_data[3*(k-1)+1] + r.rows().offset_in_output(k)*widthSteps[3*(k-1)+1]/sizeof(float) + r.cols().offset_in_output(k);
		 for(unsigned int i = 0;i<r.rows().subband_size(k,w->getAnalysingFilterLength(1));i++){
			 memcpy(	out_temp+i*widthSteps[3*(k-1)+1]/4,
						in_buffer+i*HH_buffer_widthStep/sizeof(float),
						r.cols().subband_size(k,w->getAnalysingFilterLength(1))*sizeof(float));
		}

		// uloen LH psma na vstup
		// offset do bufferu LH na platn data
		 in_buffer = LH_buffer + r.rows().offset_in_subband(k)*LH_buffer_widthStep/sizeof(float) + r.cols().offset_in_subband(k);
		 // posun ve vstupnm subbandu LH na pozici platnou pro aktuln blok
		 out_temp = o_data[3*(k-1)+2] + r.rows().offset_in_output(k)*widthSteps[3*(k-1)+2]/sizeof(float) + r.cols().offset_in_output(k);
		 for(unsigned int i = 0;i<r.rows().subband_size(k,w->getAnalysingFilterLength(1));i++){
			 memcpy(	out_temp+i*widthSteps[3*(k-1)+2]/sizeof(float),
						in_buffer+i*LH_buffer_widthStep/sizeof(float),
						r.cols().subband_size(k,w->getAnalysingFilterLength(0))*sizeof(float));
		} 

		 
		hf = max(0,w->getAnalysingFilterLength(1) - w->getAnalysingFilterLength(0));
	
		size_rows = (size_rows - w->getMaxFilterLengthRows() +1) /2;
		i_begin = LL_buffer;
		i_widthStep_float = LL_buffer_widthStep/sizeof(float);

	
/*
		// u poslednho levelu
		if(k==level) break;
		Size m = {size_cols,size_rows};
		// zabal vlevo
		if(r.cols().n == 1){
			in_buffer = LL_buffer + r.cols().offset_in_subband(k) ;
		  wrapLeftBorder_symh_32f_C1(LL_buffer,in_buffer,LL_buffer_widthStep,w.length,m);
		}
		// zabal vpravo
		if(r.cols().n == r.cols().no_of_segmets){
			in_buffer = LL_buffer + r.cols().subband_size(k)+r.cols().offset_in_subband(k) - 1;
		  wrapRightBorder_symh_32f_C1(LL_buffer,in_buffer,LL_buffer_widthStep,w.length,m);
		}

		// zabal nahore
		m.width = size_cols;
		m.height = size_rows;
		if(r.rows().n == 1){
		  in_buffer = LL_buffer + r.rows().offset_in_subband(k)*LL_buffer_widthStep/4;
		  wrapTopBorder_symh_32f_C1(LL_buffer,in_buffer,LL_buffer_widthStep,w.length,m);
		}
		// zabal dole
		if(r.rows().n == r.rows().no_of_segmets){
			in_buffer = LL_buffer + (r.rows().offset_in_subband(k)+r.rows().subband_size(k)-1)*LL_buffer_widthStep/4;
		  wrapBottomBorder_symh_32f_C1(LL_buffer,in_buffer,LL_buffer_widthStep,w.length,m);
		}
*/

		
	}

 
       // nakonec zkoprovat data z LL buferu do poslednho vstupnho subbandu
	  // do subpsma u nen dn offset, jen poet koeficient v subpsmu je pouit



	
		 out_temp = o_data[3*level] + r.rows().offset_in_output(level)*widthSteps[3*level]/sizeof(float) + r.cols().offset_in_output(level);
		 in_buffer = LL_buffer;
		 for(unsigned int i = 0;i<r.rows().subband_size(level,w->getAnalysingFilterLength(0));i++){
			// std::cout<<r.cols().subband_size(level,w->getAnalysingFilterLength(0))*sizeof(float)<<std::endl;
			 //std::cout<< w->getAnalysingFilterLength(0) <<std::endl;
			 memcpy(out_temp+i*widthSteps[3*level]/sizeof(float),
					in_buffer+i*LL_buffer_widthStep/sizeof(float),
					r.cols().subband_size(level,w->getAnalysingFilterLength(0))*sizeof(float));
			}
		 int d = 1;


		




}

bodySegDTWT2D::~bodySegDTWT2D(){
	if(H_buffer!=NULL)	releaseImage(H_buffer);	
	if(L_buffer!=NULL)	releaseImage(L_buffer);	
	if(HL_buffer!=NULL)	releaseImage(HL_buffer);
	if(HH_buffer!=NULL)	releaseImage(HH_buffer);
	if(LL_buffer!=NULL)	releaseImage(LL_buffer);
	if(LH_buffer!=NULL)	releaseImage(LH_buffer);
	}