#include "bodySegIDTWT2D.h"

// size = s + 2*(m-1)
// vsledek bude dlky floor((size -( filter_size -1))/2)
void convolveIRow(float* i, int size,float* o,float* filter,int filter_size){
    float* temp;
	for(int x=SUBSAMPLING;x<size-filter_size+1;x+=2){
		temp = i + x;
		float sum1 = 0.0f;
		for(int y=0;y<filter_size;y++){
		  sum1 += temp[y]*filter[y];
		}
        *(o + (x>>1)) = sum1 ;
		sum1 = 0;
	}
}

// konvoluce filtrem kratm ne pro kter bylo prodluovno
// filter_size je krat filtr
// vsledek je dlky floor((size -( filter_size + zerosLeft + zerosRight -1))/2) (take stejn jako ml del)
void convolveIRow(float* i, int size, float* o,float* filter,int filter_size,int zerosLeft,int zerosRight){
    float* temp;
	//int filter_size = filter_size_max - zerosRight - zerosLeft;
	for(int x=0;x<size;x++){
		temp = i + x;
		float sum1 = 0.0f;
		for(int y=0;y<filter_size;y++){
		  sum1 += temp[y]*filter[y];
		}
        *(o + x) += sum1 ;
		sum1 = 0;
	}
}



// size = s + 2*(m-1)
// vsledek bude dlky floor((size -( filter_size -1))/2)
void convolveICol(float* i, int size,int i_widthStep,float* o,int o_widthStep,float* filter,int filter_size){
    float* temp;
	int x;
	for(x=SUBSAMPLING;x<size;x+=2){
		temp = i + x*(i_widthStep);
		float sum1 = 0.0f;
		for(int y=0;y<filter_size;y++){
		  sum1 += *(temp +y*i_widthStep)*filter[y];
		}
        *(o + (x/2)*(o_widthStep) ) = sum1 ;
		sum1 = 0;
	}
}


// konvoluce sloupce filtrem kratm, ne pro kter bylo prodloueno, vstupnch koeficient by ale mlo bt stejn
void convolveICol(float* i, int size,int i_widthStep,float* o,int o_widthStep,float* filter,int filter_size,int zerosTop,int zerosBottom){
    float* temp;
	int x;
	for(x=0;x<size;x++){
		temp = i + x*(i_widthStep);
		float sum1 = 0.0f;
		for(int y=0;y<filter_size;y++){
		  sum1 += *(temp +y*i_widthStep)*filter[y];
		}
        *(o + x*o_widthStep) += sum1 ;
		sum1 = 0;
	}
}

void bodySegIDTWT2D::operator()(const tbb::blocked_range2d_segdtwt_segidtwt_auto<size_t>& r){
		int begin_cols = r.cols().begin();	// zatek bloku ve smru x
		int end_cols = r.cols().end();		// konec bloku ve smru x (u nepat do intervalu)			
		int begin_rows = r.rows().begin();	// zatek bloku ve smru y 
		int end_rows = r.rows().end();		// konec bloku ve smru y (u nepat do intervalu)
		int size_cols = end_cols - begin_cols;	// velikost bloku ve smru x
		int size_rows = end_rows - begin_rows;	// velikost bloku ve smru y
		
		// test a alokace buffer: col_buffer, row_buffer, third_buffer
		if(size_cols>maxWidth || size_rows>maxHeight){
			if(third_buffer!=NULL) { releaseImage(third_buffer); } 
			third_buffer = allocateImage_32f_C1(size_cols+2*w->getMaxFilterLengthCols(),
													   size_rows+2*w->getMaxFilterLengthRows(),&third_buffer_widthStep); 
			if(row_buffer!=NULL) { releaseImage(row_buffer); } 
			row_buffer = allocateImage_32f_C1(size_cols+2*w->getMaxFilterLengthCols(),
													 size_rows+2*w->getMaxFilterLengthRows(),&row_buffer_widthStep);
			if(col_buffer!=NULL) { releaseImage(col_buffer); } 
			col_buffer = allocateImage_32f_C1(size_cols+2*w->getMaxFilterLengthCols(),
													 size_rows+2*w->getMaxFilterLengthRows(),&col_buffer_widthStep);
			maxWidth = size_cols; maxHeight = size_rows;
		}

/************ KONEC INICIALIZACE *****************/

		// pomock promnn ukazujc na zatky dk
		float* i_row;
		int i_widthStep;
		// pomocn promnn ukazujc na zatky dk v bufferech
		float* buffer_row;

		// pomocn promnn pro offsety v bufferech
		float* in_buffer;
		int inBufferWidthStep;

		float* out_buffer;
		int outBufferWidthStep;

		float* out_temp;
		float*  in_buffer_end;

		// zjitn, jak velk je subpsmo LL v rovni level pro aktuln blok
		int subband_size_rows = r.rows().subband_size(level,w->getAnalysingFilterLength(0));
		int	subband_size_cols = r.cols().subband_size(level,w->getAnalysingFilterLength(0));

		// jak vekl je LL subpsmo pro aktuln blok v rovni level -1
		// v ppad (k-1) = 0 se vrt size_cols a size_rows
		int subband_size_rows_next = r.rows().subband_size(level-1,w->getAnalysingFilterLength(0));
		int	subband_size_cols_next = r.cols().subband_size(level-1,w->getAnalysingFilterLength(0));

		// posun v subbandu LL na pozici odpovdajc aktulnmu bloku
		i_widthStep = widthSteps[3*level];
		i_row = subbands[3*level] 
				+ r.rows().offset_in_output(level)*i_widthStep/sizeof(float)
				+ r.cols().offset_in_output(level);
		
		
		// v tomto buferu bude nadvzorkovan verze LL subpsma, nadvzorkovn v dcch, + posun o dlku filtru L od vrku
		inBufferWidthStep = col_buffer_widthStep;
		// nen -1 kuli nadvzorkovn
		in_buffer = col_buffer + (w->getSyntetizingFilterLength(0) )*inBufferWidthStep/sizeof(float);
		

		// tady bude vsledek sloupcovho nadvzorkovn, ale ji nadvzorkovan ve sloupcch, + posun od leva o dlku filtru
		outBufferWidthStep = row_buffer_widthStep;
		out_buffer = row_buffer + (w->getSyntetizingFilterLength(0) );

		// koprovn (dkov nadvzorkovn)
		for(int n = 0;n<subband_size_rows;n++){
				memcpy(in_buffer + 2*n*inBufferWidthStep/sizeof(float),
					   i_row + n*i_widthStep/sizeof(float),
					   subband_size_cols*sizeof(float));
		}
		
		// k rove dekompozice
		int Rnext = 0;
		int Ract = 0;
		/********************************************************************************************
		**************************************zatek vpoetnho cyklu******************************
		*********************************************************************************************/
		for(int k = level;k>=1;k--){
			// poet koeficient v rovni "o jedna v", mus se prodlouit zprava o r(J-(k-1))
			subband_size_rows_next = r.rows().subband_size(k-1,w->getAnalysingFilterLength(0));
			subband_size_cols_next = r.cols().subband_size(k-1,w->getAnalysingFilterLength(0));

			// zjitn, jak velk je subpsmo LL v rovni level pro aktuln blok
			subband_size_rows = r.rows().subband_size(k,w->getAnalysingFilterLength(0));
			subband_size_cols = r.cols().subband_size(k,w->getAnalysingFilterLength(0));
		


			// pro k<level musm jet pidat r(J-k) nul, ale na zatek
			
			// sloupcov konvoluce, vsledek rovnou sloupcov nadvzorkovat a odsadit od zatku
			// vsledek je v out_buffer, co je posunut row_buffer
			if(k==1)
				Rnext = 0;
			else
				Rnext = (pow2(level-k+1)-1)*(w->getSyntetizingFilterLength(0)-1);
			Ract = (pow2(level-k)-1)*(w->getSyntetizingFilterLength(0)-1);
			for(int n = 0;n<subband_size_cols + Ract;n++){
				convolveICol(col_buffer+n, (subband_size_rows_next+Rnext),col_buffer_widthStep/sizeof(float),
							 out_buffer+2*n,outBufferWidthStep/sizeof(float),
							 w->getSyntetizingFilter(0),w->getSyntetizingFilterLength(0),0,0);
			}


			// velikost subbandnu LH pro aktuln blok
			subband_size_rows = r.rows().subband_size(k,w->getAnalysingFilterLength(1));
			subband_size_cols = r.cols().subband_size(k,w->getAnalysingFilterLength(0));

			memset(col_buffer,0,(size_rows+w->getMaxFilterLengthRows())*col_buffer_widthStep);

			// posun v subbandu LH na pozici odpovdajc aktulnmu bloku
			i_widthStep = widthSteps[3*k-1];
			i_row = subbands[3*k-1] 
				+ r.rows().offset_in_output(k)*i_widthStep/sizeof(float)
				+ r.cols().offset_in_output(k);

			// v tomto buferu bude nadvzorkovan verze LH subpsma, nadvzorkovn v dcch
			inBufferWidthStep = col_buffer_widthStep;
			in_buffer = col_buffer + (w->getSyntetizingFilterLength(1))*inBufferWidthStep/sizeof(float);

			// tady bude vsledek sloupcovho nadvzorkovn, ale ji nadvzorkovan ve sloupcch
			Ract = (pow2(level-k)-1)*(w->getSyntetizingFilterLength(0)-1);
			outBufferWidthStep = row_buffer_widthStep;
			out_buffer = row_buffer + (w->getSyntetizingFilterLength(0)) + (2*Ract)*row_buffer_widthStep/sizeof(float) + 2*Ract;


			// koprovn (dkov nadvzorkovn)
			for(int n = 0;n<subband_size_rows;n++){
				memcpy(in_buffer + 2*n*inBufferWidthStep/sizeof(float),	// cl
					   i_row + n*i_widthStep/sizeof(float),				// zdroj
					   subband_size_cols*sizeof(float));					// dlka
			}

			// sloupcov konvoluce, vsledek rovnou sloupcov nadvzorkovat a odsadit od zatku
			// vsledek bude piten k out_bufferu
			if(k==1)
				Rnext = 0;
			else
				Rnext = (pow2(level-k+1)-1)*(w->getSyntetizingFilterLength(0)-1);
			//Ract = (pow2(level-k)-1)*(w->getSyntetizingFilterLength(1)-1);
			for(int n = 0;n<subband_size_cols;n++){
				convolveICol(col_buffer+n, subband_size_rows_next+Rnext- 2*Ract,inBufferWidthStep/sizeof(float),
							out_buffer+2*n,outBufferWidthStep/sizeof(float),
							w->getSyntetizingFilter(1),w->getSyntetizingFilterLength(1),0,0);
			}

			//**********************************************************************************
			// tady mm v row_buffer odsazen, sloupcov nadvzorkovan spojen LL a LH subpsmo
			//**********************************************************************************

			memset(col_buffer,0,(size_rows+w->getMaxFilterLengthRows())*col_buffer_widthStep);
			// v tomto buferu bude nadvzorkovan verze LH subpsma, nadvzorkovn v dcch
			inBufferWidthStep = col_buffer_widthStep;

			// po nsledujc konvoluci dk dostanu zase dkov nadvzorkovan a odsazen LL psmo pro dal rove
			// vsledek v i_bufferu, co je zase col_buffer posunut zhora o dlku L filtru
			if(k==1)
				Rnext = 0;
			else
				Rnext = (pow2(level-k+1)-1)*(w->getSyntetizingFilterLength(0)-1);
			Ract = (pow2(level-k)-1)*(w->getSyntetizingFilterLength(0)-1);
			if(k!=1){
					in_buffer = col_buffer + (w->getSyntetizingFilterLength(0))*inBufferWidthStep/sizeof(float)
								+ w->getRightZerosSyn(0) + w->getRightZerosSyn(0)*inBufferWidthStep/sizeof(float);
				for(int n = 0;n<subband_size_rows_next + Rnext;n++){
					convolveIRow(row_buffer + n*row_buffer_widthStep/sizeof(float), (subband_size_cols_next+Rnext ) ,
							in_buffer + 2*n*inBufferWidthStep/sizeof(float),
							w->getSyntetizingFilter(0),w->getSyntetizingFilterLength(0),0,0);
				}
			}else{
				in_buffer = col_buffer + w->getRightZerosSyn(0) + w->getRightZerosSyn(0)*inBufferWidthStep/sizeof(float);
				for(int n = 0;n<subband_size_rows_next+Rnext;n++){
					convolveIRow(row_buffer + n*row_buffer_widthStep/sizeof(float), (subband_size_cols_next+Rnext) ,
							in_buffer + n*col_buffer_widthStep/sizeof(float),
							w->getSyntetizingFilter(0),w->getSyntetizingFilterLength(0),0,0);
				}
			}
			
			//**********************************************************************************
			// col_buffer je tmto zabrn, obsahuje LL,LH nadvzorkovan, filtrovan doln propust v dcch
			//**********************************************************************************

			// subband HH
			subband_size_rows = r.rows().subband_size(k,w->getAnalysingFilterLength(1));
			subband_size_cols = r.cols().subband_size(k,w->getAnalysingFilterLength(1));
			
			// posun v subbandu HH na pozici odpovdajc aktulnmu bloku
			i_widthStep = widthSteps[3*k-2];
			i_row = subbands[3*k-2] 
				+ r.rows().offset_in_output(k)*i_widthStep/sizeof(float)
				+ r.cols().offset_in_output(k);

			// v tomto buferu bude nadvzorkovan verze HH subpsma, nadvzorkovn v dcch
			inBufferWidthStep = third_buffer_widthStep;
			in_buffer = third_buffer + (w->getSyntetizingFilterLength(1))*inBufferWidthStep/sizeof(float);
			memset(third_buffer,0,(size_rows+w->getMaxFilterLengthRows())*third_buffer_widthStep);


			// tady bude vsledek sloupcovho nadvzorkovn, ale ji nadvzorkovan ve sloupcch

			Ract = (pow2(level-k)-1)*(w->getSyntetizingFilterLength(0)-1);
			memset(row_buffer,0,(size_rows+w->getMaxFilterLengthRows())*row_buffer_widthStep);
			outBufferWidthStep = row_buffer_widthStep;
			out_buffer = row_buffer + (w->getSyntetizingFilterLength(1));


			// koprovn HH (dkov nadvzorkovn)
			for(int n = 0;n<subband_size_rows;n++){
				memcpy(in_buffer + 2*n*inBufferWidthStep/sizeof(float),
					   i_row + n*i_widthStep/sizeof(float),
					   subband_size_cols*sizeof(float));
			}

			// sloupcov konvoluce, vsledek rovnou sloupcov nadvzorkovat a odsadit od zatku
			if(k==1)
				Rnext = 0;
			else
			Rnext = (pow2(level-k+1)-1)*(w->getSyntetizingFilterLength(0)-1);
			for(int n = 0;n<subband_size_cols + Ract;n++){
				convolveICol(third_buffer+n, (subband_size_rows_next+Rnext),third_buffer_widthStep/sizeof(float),
							out_buffer+2*n,outBufferWidthStep/sizeof(float),
							w->getSyntetizingFilter(1),w->getSyntetizingFilterLength(1),0,0);
			}

			// subband HL

			subband_size_rows = r.rows().subband_size(k,w->getAnalysingFilterLength(0));
			subband_size_cols = r.cols().subband_size(k,w->getAnalysingFilterLength(1));
			
			// posun v subbandu HL na pozici odpovdajc aktulnmu bloku
			i_widthStep = widthSteps[3*k-3];
			i_row = subbands[3*k-3] 
				+ r.rows().offset_in_output(k)*i_widthStep/sizeof(float)
				+ r.cols().offset_in_output(k);


			// v tomto buferu bude nadvzorkovan verze HL subpsma, nadvzorkovn v dcch
			inBufferWidthStep = third_buffer_widthStep;
			in_buffer = third_buffer + (w->getSyntetizingFilterLength(0))*inBufferWidthStep/sizeof(float);
			memset(third_buffer,0,(size_rows+w->getMaxFilterLengthRows())*third_buffer_widthStep);

			// tady bude vsledek sloupcovho nadvzorkovn, ale ji nadvzorkovan ve sloupcch
			Ract = (pow2(level-k)-1)*(w->getSyntetizingFilterLength(0)-1);
			outBufferWidthStep = row_buffer_widthStep;
			out_buffer = row_buffer + (w->getSyntetizingFilterLength(1));

			// koprovn HL (dkov nadvzorkovn)
			for(int n = 0;n<subband_size_rows;n++){
				memcpy(in_buffer + 2*n*inBufferWidthStep/sizeof(float),
					   i_row + n*i_widthStep/sizeof(float),
					   subband_size_cols*sizeof(float));
			}

			// sloupcov konvoluce, vsledek rovnou sloupcov nadvzorkovat a odsadit od zatku
			if(k==1)
				Rnext = 0;
			else
			Rnext = (pow2(level-k+1)-1)*(w->getSyntetizingFilterLength(0)-1);
			for(int n = 0;n<subband_size_cols+Ract;n++){
				convolveICol(third_buffer+n, (subband_size_rows_next+Rnext),third_buffer_widthStep/sizeof(float),
							out_buffer+2*n,outBufferWidthStep/sizeof(float),
							w->getSyntetizingFilter(0),w->getSyntetizingFilterLength(0),0,0);
			}


			inBufferWidthStep = col_buffer_widthStep;
			
			

			// po nsledujc konvoluci dk dostanu zase dkov nadvzorkovan a odsazen LL psmo pro dal rove
			if(k==1)
				Rnext = 0;
			else
			Rnext = (pow2(level-k+1)-1)*(w->getSyntetizingFilterLength(0)-1);
			Ract = (pow2(level-k)-1)*(w->getSyntetizingFilterLength(0)-1);
			if(k!=1){
				in_buffer = col_buffer + (w->getSyntetizingFilterLength(1))*inBufferWidthStep/sizeof(float)
						+2*Ract + (2*Ract+2*Ract)*inBufferWidthStep/sizeof(float) + w->getRightZerosSyn(0)*inBufferWidthStep/sizeof(float) + w->getRightZerosSyn(0);

				for(int n = 0;n<subband_size_rows_next+Rnext - 2*Ract;n++){
					convolveIRow(row_buffer + n*row_buffer_widthStep/sizeof(float), (subband_size_cols_next+Rnext - 2*Ract) ,
							in_buffer + 2*n*inBufferWidthStep/sizeof(float),
							w->getSyntetizingFilter(1),w->getSyntetizingFilterLength(1),0,0);
				}
			}else{
				in_buffer = col_buffer + 2*Ract  + (2*Ract)*inBufferWidthStep/sizeof(float) + w->getRightZerosSyn(0)*inBufferWidthStep/sizeof(float) + w->getRightZerosSyn(0);

				for(int n = 0;n<subband_size_rows_next+Rnext - 2*Ract;n++){
					convolveIRow(row_buffer + n*row_buffer_widthStep/sizeof(float), (subband_size_cols_next+Rnext - 2*Ract) ,
							in_buffer + n*col_buffer_widthStep/sizeof(float),
							w->getSyntetizingFilter(1),w->getSyntetizingFilterLength(1),0,0);
				}
			}

			memset(row_buffer,0,(size_rows+w->getMaxFilterLengthRows())*row_buffer_widthStep);
			outBufferWidthStep = row_buffer_widthStep;
			out_buffer = row_buffer + (w->getSyntetizingFilterLength(0));


		}



// nsledn nakoprovn na vstup ( plus vchny ty pekryt)
// vsledek je v col_bufferu
		// width step v potu float
		int o_widthStep_float = o_widthStep/sizeof(float);	
		
		// posun ukazatele na zatek bloku ve vstupnch datech
		//size_t ssss = r.cols().offset_in_reconstruced();
		//size_t sss = r.rows().offset_in_reconstruced();
		float* o_begin = o_data 
							+ r.rows().offset_in_reconstruced()*o_widthStep_float 
							+ r.cols().offset_in_reconstruced();

		// posun col_bufferu
		float* col_buffer_row = col_buffer
					 + (r.rows().offset_in_reconstructed_segment() )*col_buffer_widthStep/sizeof(float)
					 + r.cols().offset_in_reconstructed_segment() ; 



		//int d = r.rows().inverse_size();
		//int dd = r.cols().inverse_size();
		for(unsigned int y = 0;y<r.rows().inverse_size();y++){
			for(unsigned int x = 0;x<r.cols().inverse_size();x++){
				*(o_begin + y*o_widthStep_float + x) +=  *(col_buffer_row + (y)*col_buffer_widthStep/sizeof(float) +x);
			}
		}
		memset(col_buffer,0,(size_rows+w->getMaxFilterLengthRows())*col_buffer_widthStep);

	}

	bodySegIDTWT2D::~bodySegIDTWT2D(){
	if(third_buffer!=NULL)	releaseImage(third_buffer);	
	if(row_buffer!=NULL)	releaseImage(row_buffer);	
	if(col_buffer!=NULL)	releaseImage(col_buffer);	
	}