#include "imageLoad.h"

using namespace std;


/*!
Funkce
*/

float* loadWrapAlignTGA(const char* name,int r, int *widthStep, Size* size){

	ifstream f(name,ios::in|ios::binary|ios::ate);
	if (!f.is_open()) {
		cout<< "File "<< name <<" does not exist" << endl;
		throw Exception("File does not exist or is damaged.");
		return 0;
	}

	TGAheader header;
	f.seekg (0, ios::beg);

	f.read((char*)&header,sizeof(TGAheader));
	if(((BYTE)!header.ImageDescriptor)&0x20 | header.ImageDescriptor&0xC0 | ((BYTE)!header.Imagetype)&0x0E) {
	cout<< "Format is not supported"<< endl;
	f.close();
		return 0;
	}
	size->width = header.Width;
	size->height = header.Height;
	std::cout<<"Image "<< name <<" found!! Loading...";
/*
byte* table = new byte[header.CMapLength*header.CMapDepth/3];
f.seekg (18, ios::beg);
f.read((char*)table,header.CMapLength*header.CMapDepth/8);
*/

// v souboru f ukazuje na 1. pixel

f.seekg (18 + header.IDLength + header.CMapLength*header.CMapDepth/8, ios::beg);
// alokace obrazu u i s okrajem
*widthStep =   (int) ( ceil(  (float) (header.Width+2*r)*sizeof(float)/ALIGN_TO_BYTES )*ALIGN_TO_BYTES );

float* result;
#ifdef __TBB_scalable_allocator_H
result = (float*) scalable_aligned_malloc(*widthStep*(header.Height+2*r),ALIGN_TO_BYTES);
#else
result = (float*) _aligned_malloc(*widthStep*height,ALIGN_TO_BYTES);
#endif

memset(result,0,*widthStep*(header.Height+2*r));

// posun ukazatele na zatek obrazu
float* data = (float*) ( result + r*(*widthStep/sizeof(float)) + r );

int rowWidth = header.Width*header.PixelDepth/8;
byte* buffer = new byte[rowWidth*header.Height];
f.read((char*)buffer,rowWidth*header.Height);

for(int y=0;y<header.Height;y++){
	for(int x=0;x<header.Width;x++){
	*(data + y**widthStep/sizeof(float) + x) = (float) buffer[(header.Height - y-1)*rowWidth + x];
	}
}

delete[] buffer;

f.close();

Size s = {header.Width,header.Height};

switch(extensionType) {
  case SYMETRIC_WP:
	  wrapBorder_symw_32f_C1(result,*widthStep,r,s);
    break;
  case CONST_PADDING:
	wrapBorder_sp0_32f_C1(result,*widthStep,r,s);
    break;
  case SYMETRIC_HP:
	 wrapBorder_symh_32f_C1(result,*widthStep,r+1,s);
    break;
  case ZEROS_PADDING:
  default: break;
}

//wrapBorder_sp0_C1<float>(result,data,*widthStep,r+1,s);
//wrapBorder_symh_C1<float>(result,data,*widthStep,r+1,s);
cout<< "loaded!" << " [" <<size->height <<","<<size->width << "] " << endl;
return result;
}


int saveTGA(const char* name,float* image, int widthStep, Size size){

	ofstream f(name,ios::binary|ios::out);
	if (!f.is_open()) {
		cout<< "Cant create file!" << endl;
		return -1;
	}

TGAheader header;
header.IDLength = 0;
header.ColorMapType = 0;
header.Imagetype = 3;
header.CMapStart = 0;
header.CMapLength = 0;
header.CMapDepth = 0;
header.XOffset = 0;
header.YOffset = 0;
header.Width = size.width;
header.Height = size.height;
header.PixelDepth = 8;
header.ImageDescriptor = 8;


f.write((char *) &header,sizeof(TGAheader));
byte* buffer = new byte[header.Width*header.Height];


for(int y=0;y<header.Height;y++){
	for(int x=0;x<header.Width;x++){
			buffer[(header.Height - y-1)*header.Width + x] = (byte) *(image + y*widthStep/sizeof(float) + x);
	}
}

f.write((char *) buffer,header.Width*header.Height) ;

delete buffer;
f.close();
	return 0;
}



void wrapBorder_sp0_32f_C1(float* o_data, int o_widthStep,int r,Size size){
//ukazatel kde zan obrzek
float* o_data_temp = (float*) ( o_data + r*(o_widthStep/sizeof(float)) + r );

// ukazatel na prodlouen obrzek
 float* o_data_begin = o_data + r*(o_widthStep/sizeof(float));
 // prodlouen levho okraje
 for(int x = 0;x<size.height;x++){
    std::fill(o_data_begin,o_data_begin + r,*(o_data_temp+x*o_widthStep/sizeof(float)));
	o_data_begin += o_widthStep/sizeof(float);
 }

  // konstantn prodlouen pravho okraje
 o_data_begin = o_data_temp + size.width;
 for(int x = 0;x<size.height;x++){
	std::fill(o_data_begin,o_data_begin+r,*(o_data_temp+x*o_widthStep/sizeof(float) + size.width -1 ));
	o_data_begin += o_widthStep/sizeof(float);
 }

 
// konstantn prodlouen hornho okraje
 o_data_begin = o_data;
 o_data_temp = (float*) ( o_data + r*(o_widthStep/sizeof(float)));
 for(int x = 0;x<r;x++){
	 memcpy(o_data_begin,o_data_temp,(size.width+ 2*( r - 1))*sizeof(float));
	o_data_begin += o_widthStep/sizeof(float);
 }

  // konstantn prodlouen dolnho okraje
 o_data_begin = o_data + (size.height + r-1)*o_widthStep/sizeof(float);
 o_data_temp = o_data_begin + o_widthStep/sizeof(float);
 for(int x = 0;x<r;x++){
	memcpy(o_data_temp,o_data_begin,(size.width+ 2*( r - 1))*sizeof(float));
	o_data_temp += o_widthStep/sizeof(float);
 }
}

void wrapBorder_symh_32f_C1(float* o_data, int o_widthStep,int r,Size size){

float* o_data_temp = (float*) ( o_data + r*(o_widthStep/sizeof(float)) + r );
//lev
 float* o_data_begin = o_data_temp - r + 1;
 for(int x = 0;x<size.height;x++){
	 std::reverse_copy(o_data_temp+x*o_widthStep/sizeof(float)-1,o_data_temp+x*o_widthStep/sizeof(float)+ r -1,o_data_begin);
   // std::fill(o_data_begin,o_data_begin+ filter_length,*(o_data_temp+x*o_widthStep/sizeof(float)));
	o_data_begin += o_widthStep/sizeof(float);
 }

  // prodlouen pravho okraje
 o_data_begin = o_data_temp + size.width;
 float* temp;
 for(int x = 0;x<size.height;x++){
	 temp = o_data_temp+x*o_widthStep/sizeof(float) + size.width - r +1;
    std::reverse_copy(temp,temp + r-1,o_data_begin);
	//std::fill(o_data_begin,o_data_begin+filter_length-1,*(o_data_temp+x*o_widthStep/sizeof(float) + size.width -1 ));
	o_data_begin += o_widthStep/sizeof(float);
 }

 
// konstantn prodlouen hornho okraje
 o_data_begin = o_data_temp - o_widthStep/sizeof(float) - ( r - 1);
 for(int x = 0;x<r-1;x++){
	 memcpy(o_data_begin,o_data_temp-( r - 1)+x*o_widthStep/sizeof(float),(size.width+ 2*( r - 1))*sizeof(float));
	o_data_begin -= o_widthStep/sizeof(float);
 }
  // konstantn prodlouen dolnho okraje
 o_data_begin = o_data_temp + (size.height)*o_widthStep/sizeof(float) - ( r - 1);
 o_data_temp = o_data_begin - o_widthStep/sizeof(float);
 for(int x = 0;x<r-1;x++){
	memcpy(o_data_begin,o_data_temp-x*o_widthStep/sizeof(float),(size.width+ 2*( r - 1))*sizeof(float));
	o_data_begin += o_widthStep/sizeof(float);
 }
}

void wrapBorder_symw_32f_C1(float* o_data, int o_widthStep,int r,Size size){

float* o_data_temp = (float*) ( o_data + r*(o_widthStep/sizeof(float)) + r );
//lev
 float* o_data_begin = o_data_temp - r + 1 + 1;
 for(int x = 0;x<size.height;x++){
	 std::reverse_copy(o_data_temp+x*o_widthStep/sizeof(float)-1,o_data_temp+x*o_widthStep/sizeof(float)+ r -1,o_data_begin);
   // std::fill(o_data_begin,o_data_begin+ filter_length,*(o_data_temp+x*o_widthStep/sizeof(float)));
	o_data_begin += o_widthStep/sizeof(float);
 }

  // prodlouen pravho okraje
 o_data_begin = o_data_temp + size.width ;
 float* temp;
 for(int x = 0;x<size.height;x++){
	 temp = o_data_temp+x*o_widthStep/sizeof(float) + size.width - r ;
    std::reverse_copy(temp+1,temp + r-1,o_data_begin);
	//std::fill(o_data_begin,o_data_begin+filter_length-1,*(o_data_temp+x*o_widthStep/sizeof(float) + size.width -1 ));
	o_data_begin += o_widthStep/sizeof(float);
 }


 
//  prodlouen hornho okraje
 o_data_begin = o_data_temp - o_widthStep/sizeof(float) - ( r - 1);
 for(int x = 0;x<r;x++){
	 memcpy(o_data_begin,o_data_temp-( r - 1)+(x+1)*o_widthStep/sizeof(float),(size.width+ 2*( r - 1))*sizeof(float));
	o_data_begin -= o_widthStep/sizeof(float);
 }
  //  prodlouen dolnho okraje
 o_data_begin = o_data_temp + (size.height)*o_widthStep/sizeof(float) - ( r - 1);
 o_data_temp = o_data_begin - 2*o_widthStep/sizeof(float);
 for(int x = 0;x<r;x++){
	memcpy(o_data_begin,o_data_temp-x*o_widthStep/sizeof(float),(size.width+ 2*( r - 1))*sizeof(float));
	o_data_begin += o_widthStep/sizeof(float);
 }
}