#include "memoryAllocation.h"


void releaseImage(void* image){
	#ifdef __TBB_scalable_allocator_H
	scalable_aligned_free(image);
	#else
	_aligned_free(image);
	#endif
//	free(image);
}

// alokuje pam a zarovn na 16 byt
float* allocateImage_32f_C1(int width, int height, int* widthStep){
*widthStep =   (int) ( ceil(  (float) width*sizeof(float)/ALIGN_TO_BYTES )*ALIGN_TO_BYTES );
float* result;
#ifdef __TBB_scalable_allocator_H
result = (float*) scalable_aligned_malloc(*widthStep*height,ALIGN_TO_BYTES);
#else
result = (float*) _aligned_malloc(*widthStep*height,ALIGN_TO_BYTES);
#endif
//float* result = (float*) malloc(*widthStep*height);
memset(result,0,*widthStep*height);
return result;
}




// alokuje 3*J+1 subband ukazatele na n jsou v poli subbands
// size je v pvodnch rozmrech obrazu
WRESULT allocateSubbands(float* subbands[],int widthSteps[],int level,int filter_length_L,int filter_length_H,Size size){
	int s_rows_L = size.height;
	int s_rows_H = size.height;
    int s_cols_L = size.width;
	int s_cols_H = size.width;

    int widthStep = 0;

	for(int x =0;x<level*3;x+=3){

	 
	 s_rows_H = (s_rows_L+filter_length_H-1)/2;
	 s_rows_L = (s_rows_L+filter_length_L-1)/2;
	 s_cols_H = (s_cols_L+filter_length_H-1)/2;
	 s_cols_L = (s_cols_L+filter_length_L-1)/2;
	 
//	 std::cout<< "Rozmery suband: " << s_cols_L << " a "<< s_cols_H << std::endl;


	 subbands[x] = allocateImage_32f_C1(s_cols_H,s_rows_L,&widthSteps[x]);
	 subbands[x+1] = allocateImage_32f_C1(s_cols_H,s_rows_H,&widthSteps[x+1]);
	 subbands[x+2] = allocateImage_32f_C1(s_cols_L,s_rows_H,&widthSteps[x+2]);
	}

    subbands[3*level] =  allocateImage_32f_C1(s_cols_L,s_rows_L,&widthSteps[3*level]);

return RESULT_OK;
}

WRESULT releaseSubbands(float* subbands[], int level){
	for(int x =0;x<level*3+1;x++)
		releaseImage(subbands[x]); 
return RESULT_OK;
}