#include "segDTWT.h"

using namespace tbb;

WRESULT segDTWTfwd_32f_C1(float* i_data, int i_widthStep, float* subbands[], int widthSteps[], int levels, Size size, separableWavelet* w){
	int filter_length = w->getMaxFilterLengthCols();
	int r = (pow2(levels) - 1)*(filter_length - 1);

	if(segSize.width == 0 && segSize.height == 0){ segSize.width = 2*r; segSize.height = 2*r; }
	Size max_size = {2*r + segSize.width, 2*r + segSize.height};

	parallel_reduce(blocked_range2d_segdtwt_segidtwt_auto<size_t>
			   (0,size.height, w->getMaxFilterLengthRows(),w->getAnalysingFilterLength(0),segSize.height,
				0,size.width , w->getMaxFilterLengthCols(),w->getAnalysingFilterLength(0),segSize.width, levels),
				bodySegDTWT2D(i_data, i_widthStep, subbands, widthSteps, max_size, w, levels), auto_partitioner());
	
	
	
	
	return RESULT_OK;
}

WRESULT segDTWTinv_32f_C1(float* subbands[],int widthSteps[], float* o_data, int o_widthStep, int levels, Size size, separableWavelet* w){
	int filter_length = w->getMaxFilterLengthCols();
	int r = (pow2(levels) - 1)*(filter_length - 1);
	if(segSize.width == 0 && segSize.height == 0){ segSize.width = 2*r; segSize.height = 2*r; }
	Size max_size = {2*r + segSize.width, 2*r + segSize.height};

	parallel_reduce(blocked_range2d_segdtwt_segidtwt_auto<size_t>(0,size.height, w->getMaxFilterLengthRows(),w->getSyntetizingFilterLength(0),segSize.height,
												0,size.width , w->getMaxFilterLengthCols(),w->getSyntetizingFilterLength(0),segSize.width, levels),
												bodySegIDTWT2D(subbands, widthSteps,o_data, o_widthStep, max_size, w, levels),
												tbb::auto_partitioner());
	
	return RESULT_OK;
}

/*
* Typ prodluovn
*/
extern wrapType extensionType = ZEROS_PADDING;

/*
* Velikost segment, kter ji nebudou dle dleny
 0,0 znamen, e bude piazeno 2*r(J)
*/
extern Size segSize = {0,0};

/*
* Vchoz soubor pro natn koeficient filtr
*/
char* waveletFile = "wavelets.dat";

